<template src="./template.html"></template>

<script lang="ts">
import { getModule } from "nuxt-property-decorator";
import { Vue, Component, Prop, Watch } from "vue-property-decorator";
import CountryFlag from "vue-country-flag";
import axios from "axios";
import { apiErrorHandler, redirectPage } from "@/utils/apiHanlers";
import { api } from "~/common/constaint";
import AdminCollectionModule from "~/store/adminCollection";
const slugify = require("slugify");
@Component({
  components: {
    MediaPicker: () => import("../../../Gallery/MediaPicker/index.vue"),
    Tree: () => import("../TreeCollection/index.vue"),
  },
})
export default class AdminShopCategoryComponent extends Vue {
  adminCollection = getModule(AdminCollectionModule, this.$store);

  dialogMediaPicker = false;

  config = {
    page: 1,
    limit: 25,
    search: "",
  };
  totalPage: number = 0;

  loadingTable = false;
  selectedAll = false;
  listCollection = [];
  listProduct = [];
  listIds = [];
  collection = {
    name: "",
    slug: "",
    desc: "",
    collectionStatus: 1,
    listProductId: [],
  };
  imageRender = "";
  bigCategory = false;

  collectionStatus = true;

  loading = false;

  beforeDestroy() {
    this.$store.commit("adminCollection/setCoverId", {
      coverId: "",
      imageUrl: "",
    });
  }

  mounted() {
    this.onGetListCollection();
    this.onGetListAllProduct();
    this.$store.commit("adminCollection/setCollectionId", "");
  }

  async onGetListAllProduct() {
    try {
      this.loadingTable = true;
      const response = await this.$api.product.getListAdmin(this.config);
      const { page, total, totalInList, data } = response.data;
      this.totalPage = Math.ceil(total / this.config.limit);
      if (response?.data?.data) {
        this.listProduct = response.data.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTable = false;
    }
  }

  async onGetListCollection() {
    try {
      const response = await this.$store.dispatch(
        "adminCollection/onGetListCollection",
        {
          ctx: this,
        }
      );
      if (response.data) {
        this.listCollection = response.data;
      }
    } catch (error) {
      console.log("error :>> ", error);
    }
  }

  onSelectImage() {
    this.dialogMediaPicker = true;
  }

  removeImage() {
    this.$store.commit("adminCollection/setCoverId", {
      coverId: "",
      imageUrl: "",
    });
  }

  async onCreateCollection() {
    try {
      // this.collection.coverId = this.$store.state.adminCollection.coverId;
      if (
        !this.collection.name ||
        !this.collection.slug ||
        !this.collection.desc
      ) {
        return this.$pushNotification.error("Please complete all information");
      }
      // else if (!this.collection.coverId) {
      // 	return this.$pushNotification.error("Please choose a photo");
      // }
      const slug = this.generateSlug(this.collection.slug);
      this.collection.slug = slug;
      if (this.collectionStatus) {
        this.collection.collectionStatus = 1;
      } else {
        this.collection.collectionStatus = 2;
      }
      // const collectionId = this.$store.state.adminCollection.collectionId;
      // if (collectionId) {
      // 	this.collection.parentCollectionId = collectionId;
      // }
      this.loading = true;
      this.collection.listProductId = this.listIds;
      const response = await this.$api.collection.create(this.collection);
      this.$pushNotification.success("Create collection successfully");
      this.collection = {
        name: "",
        slug: "",
        desc: "",
        collectionStatus: 1,
        listProductId: [],
      };
      this.onGetListCollection();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }
  generateSlug(tilte: string) {
    const options = {
      replacement: "-",
      remove: undefined,
      lower: true,
      strict: false,
      locale: "en",
      trim: true,
    };
    const slug = slugify(tilte, options);
    return slug;
  }

  convertImageProduct(data: any) {
    if (data?.listImageId?.length) {
      const { imageUrl } = data.listImageId[0];
      return `${api}/${imageUrl}`;
    }
    return "";
  }

  get convertImage() {
    const imageUrl = this.$store.state.adminCollection.imageUrl;
    if (imageUrl) {
      return `${api}/${imageUrl}`;
    }
    return "";
  }

  removeAccents(str: string) {
    return str
      .normalize("NFD")
      .replace(/[\u0300-\u036f]/g, "")
      .replace(/đ/g, "d")
      .replace(/Đ/g, "D");
  }

  @Watch("selectedAll")
  async onSelectAllChanged(value: string, oldValue: string) {
    if (value) {
      const listIds = [...this.listIds];
      //@ts-ignore
      const selectedCurrentProduct = this.listProduct
        //@ts-ignore
        .map((product) => product._id)
        //@ts-ignore
        .filter((id) => !listIds.includes(id));
      //@ts-ignore
      this.listIds = [...listIds, ...selectedCurrentProduct];
    } else {
      //@ts-ignore
      const selectedCurrentProduct = this.listProduct
        //@ts-ignore
        .map((product) => product._id);
      this.listIds = this.listIds.filter(
        (c) => !selectedCurrentProduct.includes(c)
      );
    }
  }

  @Watch("collection.name")
  changedName(val: string) {
    const parseSlug = this.removeAccents(val);
    const slug = this.generateSlug(parseSlug);
    this.collection.slug = slug;
  }

  @Watch("config.page")
  changedPage() {
    this.onGetListAllProduct();
  }
}
</script>

<style>
.thumbnails-image {
  border: 1px dashed #0091ea;
  border-radius: 8px;
  width: 216px;
  height: 216px;
}

.thumbnails-image-selected .button-remove-image {
  position: absolute;
  top: 6px;
  right: 6px;
}

.thumbnails-image-selected {
  width: 216px;
  height: 216px;
}
.height-radio {
  height: 200px;
  overflow-y: scroll;
}
</style>
